using Gtk;
using Gdk;

public class LookerControl : Application {
    private Overlay overlay;
    private Button add_gadget_button;

    public LookerControl() {
        Object(application_id: "app.hackclub.conzie.LookerControl",
                flags: ApplicationFlags.FLAGS_NONE);
    }

    protected override void activate() {
        var window = new ApplicationWindow(this);
        window.set_decorated(false);
        window.fullscreen();
        window.set_app_paintable(true);
        window.override_background_color(StateFlags.NORMAL, new RGBA(0, 0, 0, 0.5));

        overlay = new Overlay();

        add_gadget_button = new Button.from_icon_name("list-add", IconSize.LARGE);
        add_gadget_button.halign = Align.END;
        add_gadget_button.valign = Align.END;
        add_gadget_button.margin_end = 20;
        add_gadget_button.margin_bottom = 20;
        add_gadget_button.clicked.connect(() => add_clock_gadget());

        overlay.add_overlay(add_gadget_button);
        window.add(overlay);

        window.show_all;
    }

    private void add_clock_gadget() {
        var clock_gadget = new DraggableClock();
        overlay.add(clock_gadget);
        window.show_all;
    }

    public static int main(string[] args) {
        var app = new LookerControl();
        return app.run(args);
    }
}